﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace csTest
{
  public partial class Form1 : Form
  {
    private double CW, CH, IW, IH;
    public Form1()
    {
      InitializeComponent();
    }
    private int hG1 = -1, hG2 = -1, hG3 = -1;  // handles to the acop graph displays
    private int hTxt1 = -1, hTxt2 = -1; // handles to acop text displays
    private float[] y1 = new float[100];
    private float[] y2 = new float[100];
    private String[] a2lab = new String[100];
    private void button1_Click(object sender, EventArgs e)
    {
      Random r = new Random();
      for (int i = 0; i < 100; i++)
      {
        y1[i] = (float)((100.0 * r.NextDouble()));
        y2[i] = (float)((200.0 * r.NextDouble()));
      }
      if (hG1 < 0)
      {
        hG1 = acop1.Draw(y1);
        hTxt1 = acop1.PrintText("Curve 1", 80, 440);
        acop1.ForegroundColor = Color.Blue;
        hG2 = acop1.Draw(y2);
        hTxt2 = acop1.PrintText("Curve 2", 80, 380);
      }
      else
      {
        acop1.RefreshScreen(y1, hG1);
        acop1.RefreshScreen(y2, hG2);
      }
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      IW = CW = this.Width;
      IH = CH = this.Height;
      for (int i = 0; i < 100; i++) a2lab[i] = "Element " + i;
    }

    private void button2_Click(object sender, EventArgs e)
    {
      Random r = new Random();
      for (int i = 0; i < 100; i++)
      {
        y1[i] = (float)((100.0 * r.NextDouble()));
      }
      acop2.ClearScreen(-1, 5);
      acop2.Draw(y1,a2lab);
    }

    private void Form1_ResizeEnd(object sender, EventArgs e)
    {
      double RW = (this.Width - CW) / CW;
      double RH = (this.Height - CH) / CH;

      foreach (Control c in Controls)
      {
        c.Width += (int)(c.Width * RW);
        c.Height += (int)(c.Height * RH);
        c.Left += (int)(c.Left *RW);
        c.Top += (int)(c.Top *RH);
      }
      CW = this.Width;
      CH = this.Height;
    }
    private double GetUtcNow()
    {
      DateTime startDate = new DateTime(1970, 1, 1); // get UTC seconds
      return (DateTime.Now - startDate).TotalSeconds;
    }
    Random rn = new Random();
    private void button3_Click(object sender, EventArgs e)
    {
      if (hG3 < 0)
      {
        acop3.XMax = GetUtcNow();
        acop3.XMin = acop3.XMax - 100;
        hG3 = acop3.Draw(rn.NextDouble() * 30, acop3.XMax, 1, 100);
      }
      timer1.Enabled = true;
    }

    private void timer1_Tick(object sender, EventArgs e)
    {
      if (hG3 < 0) return;
      acop3.AppendScreen(rn.NextDouble() * 30, hG3, GetUtcNow());
    }
    private void checkBox1_CheckedChanged(object sender, EventArgs e)
    {
      acop3.AbsoluteTimeDisplay = checkBox1.Checked;
    }

    private void acop2_acopMsMove(object sender, AcopChart.AcopEvent e)
    {
      int i = e.GetArrayIndex();
      acop2.ToolTipText = a2lab[i];
    }
  }
}
